/*
 *	G	XebsO[^
 *
 *		gp{[h
 *			ADM-001: PIC 16F627A
 *			ADM-105: ROTARY ENCODER
 *			ADM-206: STEPPING MOTOR
 *
 *		ڑ
 *			ADM-001			ADM-105
 *			RA0				A
 *			RA1				B
 *
 *			ADM-001			ADM-206
 *			RB0				P1
 *			RB1				P2
 *			RB2				P3
 *			RB3				P4
 *
 *							2009N1001
 */


/*
	CN[h
 */
#include <pic.h>


/*
	RtBM[V[h̐ݒ
 */
//__CONFIG ( CP_OFF & LVP_OFF & BOREN_ON & MCLRE_ON & PWRTE_ON & WDTE_OFF & FOSC_INTOSCIO );
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

int getDir ( unsigned int pre , unsigned int cur );

/*
	}N`
 */
// ]o}N
#define ROT_F		1		// ]
#define ROT_R		2		// t]
#define ROT_ERROR	-1		// ]s
#define ENCODER_VAL	(PORTA & 0x03)		// GR[_lo}N


/*
	㎥p^[z
 */
//const char a_stmotor[4] = { 0x08, 0x04, 0x02, 0x01 };	// 1㎥p^[
//const char a_stmotor[4] = { 0x09, 0x0c, 0x06, 0x03 };	// 2㎥p^[
const unsigned char a_stmotor[8] = { 0x08, 0x0c, 0x04, 0x06, 0x02, 0x03, 0x01, 0x09 };	// 1-2㎥p^[


/*
	main֐
 */
void main( void ){
	
	/*
		]ô߂̃GR[_lrp
			pre :]ÕGR[_li[
			cur :]̃GR[_li[
	 */
	unsigned int pre, cur;
	
	unsigned int dir;
	
	unsigned char stmotor_ptn = 0;		// ㎥p^[z̓Yp
	unsigned int i;						// Eh~̎ԂԂp
	
	/* |[g */
	CMCON = 0x07;			// RA0`3o͒[qɐݒ
	PORTA = 0x00;			// PORTA̓dx
	PORTB = 0x00;			// PORTB̓dx
	TRISB = 0b00000000;		// Sďo͂ɐݒiڑ{[hFXebsO[^j
	TRISA = 0b00100011;		// RA0,RA1͂ɐݒiڑ{[hF[^GR[_j
	
	pre = ENCODER_VAL;		// ]ÕGR[_l擾
	
	while(1){
		
		// GR[_̉]҂
		if ( pre != ENCODER_VAL ){
		
			cur = ENCODER_VAL;		// ]̃GR[_l擾
			
			dir = getDir( pre , cur );		// GR[_̉]o
			
			// v
			if ( dir == ROT_F ){
				if( stmotor_ptn >= 7 )	{	stmotor_ptn = 0;	}
				else					{	stmotor_ptn++;		}
			}
			// v
			else if ( dir == ROT_R ){
				if( stmotor_ptn <= 0 )	{	stmotor_ptn = 7;	}
				else					{	stmotor_ptn--;		}
			}
			else{
				/*
					]ołȂꍇ̏Lq
				 */
			}
			
			PORTB = a_stmotor[stmotor_ptn];		// [^]
			
			for( i = 0; i < 1000; i++ )		// Eh~
				;
			
			pre = ENCODER_VAL;		// ]ÕGR[_lƂĊi[
		}
	}
}


/*
	]o֐
		1F pre ]ÕGR[_l
		2F cur ]̃GR[_l
		߂lF dir ]
 */
int getDir ( unsigned int pre , unsigned int cur ){
	
	if ( ( pre == 0 && cur == 2 ) || ( pre == 2 && cur == 3 ) || ( pre == 3 && cur == 1 ) || ( pre == 1 && cur == 0 ) ){
		return ( ROT_F );
	}
	else if ( ( pre == 0 && cur == 1 ) || ( pre == 1 && cur == 3 ) || ( pre == 3 && cur == 2 ) || ( pre == 2 && cur == 0 ) ){
		return ( ROT_R );
	}
	else{
		return ( ROT_ERROR );
	}
}

