/*
 *	G	ȈՓd
 *
 *		gp{[h
 *			ADM-001: PIC 16F627A
 *			ADM-102: PUSH SWITCH MATRIX
 *			ADM-202: LCD 16~2
 *
 *		ڑ
 *			ADM-001			ADM-202
 *			RA0				D4
 *			RA1				D5
 *			RA2				D6
 *			RA3				D7
 *			RA6				E
 *			RA7				RS
 *
 *			ADM-001			ADM-102
 *			RB0				P1
 *			RB1				P2
 *			RB2				P3
 *			RB3				P4
 *			RB4				P5
 *			RB5				P6
 *			RB6				P7
 *			RB7				P8
 *
 *							2009N1001
 */


/*
	CN[h
 */
#include <pic.h>
#include "lcd.h"
#include "timer.h"


/*
	RtBM[V[h̐ݒ
 */
//__CONFIG(UNPROTECT & UNPROTECT & LVPDIS & BOREN & MCLREN & PWRTEN & WDTDIS & INTIO);
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

/*
	vg^Cv錾
 */
void inputNum( unsigned char state );	// ͂֐
void inputOpe( void );					// Z͂֐
void result( void );					// vZCʂ\֐


/*
	}N`
 */
#define	LV_H			1						// Hx
#define	LV_L			0						// Lx
#define	STATE_NUM1		0						// vO1
#define	STATE_NUM2		1						// vO2
#define	STATE_OPE		2						// vO3
#define	STATE_RESULT	3						// vO4
#define	STATE_WAIT		4						// vO5
#define	lcd_putc(c)		LCD_RS=1,lcd_write(c)	// LCD\p}N


/*
 	O[oϐ
 */
unsigned char g_ope;			// Zi[
unsigned char g_cnt;			// ҂Ԋ֐p

// vZΏۂ̐i[z
// a_num[0]:1ڂ̐i[		a_num[1]:2ڂ̐i[
unsigned char a_num[2]={0,0};	


// \鐔z
const unsigned char a_val[] = { '0','1','2','3','4','5','6','7','8','9' };

// \鉉Zz
const unsigned char a_ope[] = { '+' , '-' , '*' , '/' };


/*
 	main֐
 */
void main( void ){
	
	unsigned char state;		// vOԂi[
	
	/* |[g̏ */
	CMCON = 0x07;	// RA0`3o͒[qɐݒ
	TRISA = 0x20;	// RA5ȊOo͒[qɐݒiڑ{[hFLCDj
	TRISB = 0xf0;	// 4rbǵC4rbgo͂ɐݒiڑ{[hFhbg}gNXSWj
	PORTA = 0x00;	// PORTA̓dx
	PORTB = 0x01;	// PORTB̓dx
	
	/* ݋ */
	PEIE = 1;		// Ӌ@\݂̋
	GIE	 = 1;		// ݑŜ̋
	
	tmr1Func();				// ^C}1ݐݒi҂Ԋ֐Ɏgpj
	
	/* LCD̏ */
	lcd_init();
	lcd_clear( );
	
	tmr2Func();				// ^C}2ݐݒihbg}gNXSWւ̃pXo͂Ɏgpj
	
	state =  STATE_NUM1;	// vO1ɐݒ
	
	// iv[v
	while(1){
		
		// vȌԂɂ蕪
		switch ( state ){
			
			/* 1̏ꍇi1ڂ̐͂ƉŹj */
			case STATE_NUM1:{
				
				inputNum(state);	// l͗p֐Ăяo
				
				// 1ڂ̐͌CZSWꍇ
				if ( RB4 && a_num[0] > 0){
					TMR2ON = 0;				// ^C}2~
					state = STATE_OPE;		// vO2
				}
				break;
			}
			
			/* 2̏ꍇiZ\j */
			case STATE_OPE:{
				
				inputOpe();			// Z͗p֐Ăяo
				state = STATE_NUM2;	// vO3
				
				break;
			}
			
			/* 3̏ꍇi2ڂ̐́j */
			case STATE_NUM2:{
				
				inputNum(state);	//	l͗p֐Ăяo
				
				// 2ڂ̐͌C" = "SW̏
				if( (RB7 == LV_H && RB3 == LV_H) ){
					state = STATE_RESULT;		// vO4
				}
				break;
			}
			
			/* vZ */
			case STATE_RESULT:{
				
				result();		// vZp֐Ăяo
				
				TMR2ON = 0;		// ^C}2~
				
				state = STATE_WAIT;		// vO5
				break;
			}
			
			/* I */
			case STATE_WAIT:{
				break;
			}
		}
	}
}


/*
	݃T[rX[`
		ݗvF^C}1 / ^C}2
 */
static void __interrupt() isr(void){
	
	/* ^C}1ݏ ҂Ԋ֐p */
	if (TMR1IF == 1 ){
		g_cnt--;
		TMR1IF = 0;
		TMR1L = 0b00010111;
		TMR1H = 0b11111100;
	}
	
	/* ^C}2ݏ hbg}gNXSW֏pXo */
	else if ( TMR2IF == 1 ){
		if ( RB3 == 1 )	{	PORTB = 0x01;	}
		else			{	PORTB <<= 1;	}
		TMR2IF = 0;
	}
}

/*
	l͊֐
		F1ڂ̐istate : 0j or 2ڂ̐istate : 1j
 */
void inputNum( unsigned char state ){
	
	unsigned char wk = 0;	// ǂ̐ꂽi[ϐ
	
	// ꂽ̏
	if( RB5 == LV_H || (RB6 == LV_H && RB3 == LV_L) || (RB7 == LV_H && RB3 == LV_L) ) {
		
		TMR2ON = 0;			// ^C}2~
		
		/* ǂSWꂽo */
		if ( RB7 ){
			if ( RB0 )		{	wk = 1;	}	// 1͂ꂽꍇ
			else if ( RB1 )	{	wk = 2;	}	// 2͂ꂽꍇ
			else if ( RB2 )	{	wk = 3;	}	// 3͂ꂽꍇ
		}
		if ( RB6 ){
			if ( RB0 )		{	wk = 4;	}	// 4͂ꂽꍇ
			else if ( RB1 )	{	wk = 5;	}	// 5͂ꂽꍇ
			else if ( RB2 )	{	wk = 6;	}	// 6͂ꂽꍇ
		}
		if ( RB5 ){
			if ( RB0 )		{	wk = 7;	}	// 7͂ꂽꍇ
			else if ( RB1 )	{	wk = 8;	}	// 8͂ꂽꍇ
			else if ( RB2 )	{	wk = 9;	}	// 9͂ꂽꍇ
			else if ( RB3 )	{	wk = 0;	}	// 0͂ꂽꍇ
		}
		
		a_num[state] = a_num[state]*10+wk;	// XV
		
		TMR2ON = 1;				// ^C}2N
		DelayMs(250);			// `^O΍
		lcd_putc( a_val[wk] );	// \
	}
}


/*
	Z͊֐
 */
void inputOpe( void ){

	if     (RB0 == LV_H){	g_ope = 0;	}	// Z+͂ꂽꍇ
	else if(RB1 == LV_H){	g_ope = 1;	}	// Z-͂ꂽꍇ
	else if(RB2 == LV_H){	g_ope = 2;	}	// Z*͂ꂽꍇ
	else if(RB3 == LV_H){	g_ope = 3;	}	// Z/͂ꂽꍇ
	
	TMR2ON = 1;				// ^C}2N
	DelayMs(250);			// `^O΍
	lcd_putc( a_ope[g_ope] );	// Z\
}


/*
	vZp֐
 */
void result( void ){
	
	char ans;	// vZʂ̊i[p
	
	switch ( g_ope ){
		case 0:	ans = a_num[0] + a_num[1];	break;	// Z̏ꍇ̏
		case 1:	ans = a_num[0] - a_num[1];	break;	// Z̏ꍇ̏
		case 2:	ans = a_num[0] * a_num[1];	break;	// Z̏ꍇ̏
		case 3:	ans = a_num[0] / a_num[1];	break;	// Z̏ꍇ̏
	}
	
	lcd_pos ( 0x40 );	// J[\2sڂɈړ
	
	/* vZʂ\ */
	if ( ans > 99 )	{	lcd_putc(a_val[ans/100] );		}	// vZʂ3ȏ̏ꍇC3ڂ\
	if ( ans > 9 )	{	lcd_putc(a_val[(ans/10)%10] );	}	// vZʂ2ȏ̏ꍇC2ڂ\
	lcd_putc(a_val[ans%10] );								// 1ڂ\
	
	TMR2ON = 0;
}